<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML3.2 EN">
<HTML>
<HEAD>
<META NAME="GENERATOR" CONTENT="DOCTEXT">
<TITLE>MatGetArray</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF">
<A NAME="MatGetArray"><H1>MatGetArray</H1></A>
Returns a pointer to the element values in the matrix. The result of this routine is dependent on the underlying matrix data structure, and may not even work for certain matrix types.  You MUST call <A HREF="../Mat/MatRestoreArray.html#MatRestoreArray">MatRestoreArray</A>() when you no longer need to access the array. 
<H3><FONT COLOR="#CC3333">Synopsis</FONT></H3>
<PRE>
#include "petscmat.h" 
PetscErrorCode  MatGetArray(Mat mat,PetscScalar *v[])
</PRE>
Not Collective
<P>
<H3><FONT COLOR="#CC3333">Input Parameter</FONT></H3>
<DT><B>mat </B> -the matrix
<br>
<P>
<H3><FONT COLOR="#CC3333">Output Parameter</FONT></H3>
<DT><B>v </B> -the location of the values
<br>
<P>
<P>
<H3><FONT COLOR="#CC3333">Fortran Note</FONT></H3>
This routine is used differently from Fortran, e.g.,
<PRE>
        <A HREF="../Mat/Mat.html#Mat">Mat</A>         mat
        <A HREF="../Sys/PetscScalar.html#PetscScalar">PetscScalar</A> mat_array(1)
        PetscOffset i_mat
        <A HREF="../Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr
        call <A HREF="../Mat/MatGetArray.html#MatGetArray">MatGetArray</A>(mat,mat_array,i_mat,ierr)

  C  Access first local entry in matrix; note that array is
  C  treated as one dimensional
        value = mat_array(i_mat + 1)

        [... other code ...]
        call <A HREF="../Mat/MatRestoreArray.html#MatRestoreArray">MatRestoreArray</A>(mat,mat_array,i_mat,ierr)
</PRE>

<P>
See the Fortran chapter of the users manual and
petsc/src/mat/examples/tests for details.
<P>

<P>
<P>
<H3><FONT COLOR="#CC3333">C++ variants</FONT></H3><TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD> PetscScalar* MatGetArray(Mat mat)<TD WIDTH=20></TD><TD>-></TD><TD WIDTH=20></TD><TD>MatGetArray(mat,&a); return a;</TR></TD>

</TABLE>
<H3><FONT COLOR="#CC3333">See Also</FONT></H3>
 <A HREF="../Mat/MatRestoreArray.html#MatRestoreArray">MatRestoreArray</A>(), <A HREF="../Mat/MatGetArrayF90.html#MatGetArrayF90">MatGetArrayF90</A>()
<BR><P><B><P><B><FONT COLOR="#CC3333">Level:</FONT></B>advanced
<BR><FONT COLOR="#CC3333">Location:</FONT></B><A HREF="../../../src/mat/interface/matrix.c.html#MatGetArray">src/mat/interface/matrix.c</A>
<BR><A HREF="./index.html">Index of all Mat routines</A>
<BR><A HREF="../../index.html">Table of Contents for all manual pages</A>
<BR><A HREF="../singleindex.html">Index of all manual pages</A>
</BODY></HTML>
